#!/usr/bin/env bash
# !/bin/sh

#打包脚本
gradle_arg="aR"

#mtl java_home config use :   -Dorg.gradle.java.home=/usr/alibaba/jdk1.8.0_25
#java_home="-Dorg.gradle.java.home=/Library/Java/JavaVirtualMachines/jdk1.8.0_131.jdk/Contents/Home"
java_home="-Dorg.gradle.java.home=/usr/alibaba/jdk1.8.0_25"

while getopts ":g:t:o:j:" opt; do
    case $opt in
        g)
gradle_variant=$OPTARG
;;
j)
java_home=$OPTARG
;;
t)
CHANNEL_LIST=$OPTARG
;;
\?)
echo "Invalid option: -$OPTARG" >&2
exit 1
;;
esac
done

if [ "$java_home" != "" ] ; then
    gradle_arg=$gradle_arg" "$java_home
fi

#获取渠道号
ttids=${CHANNEL_LIST}
echo "TTIDS: $ttids"
if [ "$ttids" = "" ]; then
    echo "not found ttid"
    ./gradlew clean $gradle_arg
    exit 0
fi
ttids=$(echo $ttids | tr "," "\n")

#打包APK，打包开始前先替换回原来的 config.xml
packageApk(){
    ./gradlew $gradle_arg --refresh-dependencies -Pttid=$1 -Pflag=release
}

./gradlew clean
for x in $ttids
do

    echo "[start package] $x channel ---------------------------------"
    packageApk $x
    echo "[end package]---------------------------------"
done


echo $PWD
echo "find my apks ... "
echo "---------------------------------"
find . -name *.apk

echo "build completed---------------------------------"