package com.alibaba.alink.opensdksample.net;

import android.app.Activity;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.text.method.ScrollingMovementMethod;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

import com.alibaba.alink.opensdksample.R;
import com.aliyun.alink.sdk.net.anet.api.persistentnet.EventDispatcher;
import com.aliyun.alink.sdk.net.anet.api.persistentnet.IOnPushListener;

public class EventDispatcherDemoActivity extends Activity {

    TextView textView;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_event_dispatcher);

        textView = (TextView) findViewById(R.id.textview_main);
        textView.setMovementMethod(new ScrollingMovementMethod());
    }

    @Override
    protected void onPostCreate(@Nullable Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);

        EventDispatcher.getInstance().registerOnPushListener(new IOnPushListener() {
            @Override
            public void onCommand(String s) {
                textView.append(s);
                textView.append("\r\n");
            }

            @Override
            public boolean filter(String s) {
                return true;
            }
        }, true);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_event_dispatcher, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        if (R.id.men_event_dispatcher_clear == item.getItemId()) {
            textView.setText("");
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
